#
# $Id: php5.spec,v 1.2 2004/07/14 13:20:33 build Exp $
#

# Determine our parallelism.
%define	_smp_mflags	%(RPM_BUILD_NCPUS="`/usr/bin/getconf _NPROCESSORS_ONLN`"; [ "$RPM_BULD_NCPUS" -gt 1 ] && echo "-j$RPM_BUILD_NCPUS")

Summary:	The PHP scripting language.
Name:		php5
License:	PHP
Version:	5.0.4
Release:	1.5.5
Group:		Development/Languages
URL:		http://www.php.net/
Source0:	php-%{version}.tar.bz2
Patch0:		php-5.0.0RC3-php.ini-gd-1.diff
BuildRoot:	%{_tmppath}/%{name}-%{release}-root
BuildPrereq:	apache-devel

%description
PHP is an HTML-embeddable scripting language.  PHP offers built-in database
integration for several commercial and non-commercial database management
systems, so writing a database-enabled script with PHP is fairly simple.  The
most common use of PHP coding is probably as a replacement for CGI scripts.

%files
  %defattr(-,root,root)
  %doc CODING_STANDARDS CREDITS EXTENSIONS INSTALL LICENSE NEWS README.CVS-RULES
  %doc README.EXTENSIONS README.EXT_SKEL README.PARAMETER_PARSING_API
  %doc README.PHP4-TO-PHP5-THIN-CHANGES README.QNX
  %doc README.SELF-CONTAINED-EXTENSIONS README.STREAMS README.SUBMITTING_PATCH
  %doc README.TESTING README.TESTING2 README.UNIX-BUILD-SYSTEM
  %doc README.WIN32-BUILD-SYSTEM README.Zeus README.input_filter TODO TODO-PHP5
  %doc TODO.BUILDv5 Zend/ChangeLog Zend/LICENSE Zend/OBJECTS2_HOWTO
  %doc Zend/ZEND_CHANGES Zend/ZEND_LICENSE

  %attr(0644,root,root)	%config /etc/php5/php.ini
  %attr(0555,root,root)	%{_bindir}/php5
  %attr(700,webd,root)	/var/run/php

%package -n mod_php5
Summary:	The PHP HTML-embedded scripting language for use with Apache.
Group:		System Environment/Daemons
Prereq:		webserver
Obsoletes:	php3, phpfi
BuildPrereq:	apache-devel
Prereq:		php5 = %{version}-%{release}

%description -n mod_php5
PHP is an HTML-embedded scripting language.  PHP attempts to make it
easy for developers to write dynamically generated web pages.  PHP
also offers built-in database integration for several commercial and
non-commercial database management systems, so writing a
database-enabled web page with PHP is fairly simple.  The most common
use of PHP coding is probably as a replacement for CGI scripts.  The
mod_php module enables the Apache web server to understand and process
the embedded PHP language in web pages.

%files -n mod_php5
  %defattr(-,root,root)
  %attr(0555,root,root)	%{_sysconfdir}/httpd/modules/mod_php5.so

%package mysql
Group:		Development/Languages
Prereq:		php5 = %{version}-%{release}, perl
Summary:	A module for PHP applications that use MySQL databases.
Provides:	php_database
Obsoletes:	mod_php3-mysql
BuildPrereq:	MySQL-devel
Requires:	MySQL

%description mysql
The php-mysql package contains a dynamic shared object that will add
MySQL database support to PHP.  MySQL is an object-relational database
management system.  PHP is an HTML-embeddable scripting language.  If
you need MySQL support for PHP applications, you will need to install
this package and the php or mod_php package.

%files mysql
  %defattr(-,root,root)
  %attr(0555,root,root)	%{_libdir}/php5/extensions/mysql.so

%package imap
Group:		Development/Languages
Prereq:		php5 = %{version}-%{release}, perl
Requires:	imap, pam
Summary:	A module for PHP applications that use IMAP.
BuildPrereq:	imap-devel

%description imap
The php-imap package contains a dynamic shared object that will add IMAP
(Internet Message Access Protocol) support to PHP. IMAP is a protocol
for retrieving, uploading, and manipulating e-mail messages on mail servers.
PHP is an HTML-embeddable scripting language.  If you need IMAP support
for PHP applications, you will need to install this package and the php

%files imap
  %defattr(-,root,root)
  %attr(0555,root,root)	%{_libdir}/php5/extensions/imap.so

%prep
%setup -q -n php-%{version}
%patch0 -p1

%build
  export CFLAGS="$RPM_OPT_FLAGS -fPIC"

  #
  # Function used for building both PHP standalone and modules.
  #
  compile() {
	./configure \
		--prefix=%{_prefix} \
		--sysconfdir=%{_sysconfdir}/php5 \
		--with-config-file-path=%{_sysconfdir}/php5 \
		--disable-debug \
		--enable-pic \
		--enable-inline-optimization \
		--with-exec-dir=%{_bindir} \
		--with-gettext \
		--with-gdbm \
		--without-mysql \
		--with-xml \
		--with-zlib \
		--with-jpeg-dir=%{_prefix} \
		--with-gd \
		--enable-magic-quotes \
		--enable-safe-mode \
		--enable-sysvsem \
		--enable-sysvshm \
		--enable-track-vars \
		--enable-ftp \
		--enable-calender \
		--enable-sockets \
		--enable-bcmath \
		--enable-pear \
		--disable-yp \
		--with-openssl \
		--enable-versioning \
		--with-ldap \
		--enable-force-cgi-redirect \
		--with-ldap \
		--enable-soap \
		$*
	make %{?_smp_mflags}
  }
# --with-curl \
# --with-snmp \

  #
  # Function used for building PHP modules.
  #
  build_ext() {
	%{__cc} -fPIC -shared $RPM_OPT_FLAGS \
		-DCOMPILE_DL_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-DHAVE_`echo $1 | tr '[a-z]' '[A-Z]'` \
		-I. -I./main -I`%{_sbindir}/apxs -q INCLUDEDIR` -I./Zend \
		-I/usr/include/freetype -I/usr/include/$1 \
		-I./ext/$1 -I./ext/$1/lib$1 \
		-I./ext/xml/expat/xmltok -I./ext/xml/expat/xmlparse \
		-I./TSRM \
		`grep ^CPPFLAGS Zend/Makefile | cut -f2- -d=` \
		$4 $2 -o $1.so -L.libs $3 -lc
  }

  # Build it.
  compile --with-apxs=%{_sbindir}/apxs --enable-force-cgi-redirect --enable-discard-path

  # Build the PHP modules.
  build_ext mysql ext/mysql/php_mysql.c "-L/usr/lib/mysql -lmysqlclient" "-DHAVE_MYSQL_MYSQL_H -DHAVE_MYSQL_REAL_CONNECT"
  build_ext imap ext/imap/php_imap.c "%{_libdir}/libc-client.a -lpam" "-DHAVE_IMAP2000"

%install
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT
  mkdir -p $RPM_BUILD_ROOT/%{_libdir}/php5/extensions
  mkdir -p $RPM_BUILD_ROOT/%{_sysconfdir}/{httpd/modules,php5}
  mkdir -p $RPM_BUILD_ROOT/%{_bindir}
  mkdir -p $RPM_BUILD_ROOT/var/log/httpd
  mkdir -p $RPM_BUILD_ROOT/var/run/php

  install sapi/cli/php     $RPM_BUILD_ROOT/%{_bindir}/php5
  install mysql.so         $RPM_BUILD_ROOT/%{_libdir}/php5/extensions/
  install imap.so          $RPM_BUILD_ROOT/%{_libdir}/php5/extensions/
  install .libs/libphp5.so $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/modules/mod_php5.so
  install php.ini-dist     $RPM_BUILD_ROOT/%{_sysconfdir}/php5/php.ini

  strip -g $RPM_BUILD_ROOT/%{_libdir}/php5/extensions/*
  strip -g $RPM_BUILD_ROOT/%{_sysconfdir}/httpd/modules/*

%post
  touch $RPM_BUILD_ROOT/var/log/httpd/php5_error.log

%post -n mod_php5
  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%postun -n mod_php5
  # Maybe restart Apache.
  if [ -f /var/lock/subsys/httpd ]; then
        /etc/init.d/httpd restart > /dev/null 2>&1 || :
  fi

%post mysql
  %{__perl} -pi -e "s|^;extension=mysql.so|extension=mysql.so|" /etc/php5/php.ini

%preun mysql
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=mysql.so|;extension=mysql.so|" /etc/php5/php.ini
  fi

%post imap
  %{__perl} -pi -e "s|^;extension=imap.so|extension=imap.so|" /etc/php5/php.ini

%preun imap
  if [ $1 = 0 ] ; then
	%{__perl} -pi -e "s|^extension=imap.so|;extension=imap.so|" /etc/php5/php.ini
  fi

%clean
  [ "$RPM_BUILD_ROOT" != "/" ] && rm -rf $RPM_BUILD_ROOT

%changelog
* Tue Apr 19 2005 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.0.4, Release 1.5.5
  - Upgrade to 5.0.4 and rebuild against our latest Apache.
  - Bring in _smp_mflags.

* Wed Jul 14 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.0.0, Release 1.5.4
  - Update to 5.0.0 proper.

* Fri Jul 09 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.0.0, Release 1.5.3
  - Update to RC3 and backport to Thrust.
  - Disable cURL and SNMP support.

* Wed Apr 07 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.0.0, Release 1.5.2
  - Move mod_php5.so into /etc/httpd/modules where it belongs.
  - EnGarde-ize php.ini.
  - Don't package php5_error.log -- just touch it in %post.

* Fri Apr 02 2004 Ryan W. Maple <ryan@guardiandigital.com>
- Version 5.0.0, Release 1.5.1
  - Make 'php5' a seperate package from 'php' so both may co-exist.
  - Initial build for EnGarde.
